
  String asteriskUrl = "http://ec2-75-101-233-88.compute-1.amazonaws.com/webservice/getdata.php";
  String lines[]; 
  String lastts = "0";

  Timer timer;
  
  HashMap calls;

  PFont f;
      
  void setup()
  {  
    calls = new HashMap();
    timer = new Timer();
    timer.scheduleAtFixedRate(new TimerTask() {
            public void run() {
              loadIt();
            }
        }, 1000, 1000);    
        
    f = createFont("Georgia",18,true);       
    textFont(f);  
    
    size(640,480);
    smooth();
  }

  void draw()
  {    
    background(0);
    // This is how we iterate through each call object
    Iterator i = calls.values().iterator();
    while (i.hasNext()) {
      Call c = (Call) i.next();
      c.render();
    } 
  }

  public void loadIt()
  {
    println("Hitting: " + asteriskUrl + "?ts=" + lastts);
    lines = loadStrings(asteriskUrl + "?ts=" + lastts);    

    if (lines.length > 0)
    {
      // Loop through the lines that we got
      for (int i = 0; i < lines.length; i++)
      {
        println(lines[i]);
        
        // Split each line to get the data out
        String[] currentline = split(lines[i],',');
        for (int j = 0; j < currentline.length; j++)
        {
          // currentline[0] is the timestamp
          // currentline[1] is the caller's unique id
          // currentline[2] is the caller id
          // currentline[3] is the digit
         
         if (!calls.containsKey(currentline[1]))
         {
            // Call(String _caller_id, String _unique_id, String _lastts, String _lastdigit) 
            Call newcall = new Call(currentline[2],currentline[1],currentline[0],currentline[3]);
            calls.put(newcall.unique_id,newcall);
         } 
         else
         {
           Call existingcall = (Call) calls.get(currentline[1]);
           existingcall.newdigit(currentline[0], currentline[3]);
         }
  
          // Save the last timestamp
          if (j == lines.length - 1)
          {
            lastts = currentline[0];
          }
        }
      }
    } 
  }

